"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var fs = require("fs");
var configFactory_1 = require("./utils/configFactory");
var filterXML_1 = require("./utils/filterXML");
var isSlotLive_1 = require("./utils/isSlotLive");
var recursiveSearch_1 = require("./utils/recursiveSearch");
var checkContentAssetForSiteSpecific_1 = require("./utils/checkContentAssetForSiteSpecific");
var jsonfile = require('jsonfile');
var App = /** @class */ (function () {
    function App(config) {
        var _this = this;
        this.checkSlotForValues = function (slot, values) {
            for (var _i = 0, values_1 = values; _i < values_1.length; _i++) {
                var check = values_1[_i];
                if (slot[check.key] === check.value) {
                    return true;
                }
            }
            return false;
        };
        this.configHasKeys = function (values) {
            return values.length > 0;
        };
        this.filterXML = function (config) {
            if (config === void 0) { config = _this.state.config; }
            // function uses partial application to store value in clojure
            var siteSpecificCheck = checkContentAssetForSiteSpecific_1.curriedCheckForContentId(config.siteSpecificKey);
            _this.state.filteredPayload = filterXML_1.filterXML(config.inputPath, function (slot) {
                // by default we should keep the slot
                var remove = false;
                var siteSpecific = false;
                var keep = false;
                // if keep alive and its false return false
                if (config.keepAlive && !isSlotLive_1.isSlotAlive(slot)) {
                    return false;
                }
                recursiveSearch_1.recursiveSearch(slot, function (slot) {
                    if (config.siteSpecificKey.length > 0 && siteSpecificCheck(slot)) {
                        siteSpecific = true;
                        return true;
                    }
                    if (_this.configHasKeys(config.toRemove)) {
                        if (_this.checkSlotForValues(slot, config.toRemove)) {
                            remove = true;
                            return true;
                        }
                    }
                    if (_this.configHasKeys(config.toKeep)) {
                        if (_this.checkSlotForValues(slot, config.toKeep)) {
                            keep = true;
                            return true;
                        }
                    }
                    else {
                        // if no values then keep is true by default but we dont want to return
                        // but this overrides all the other configs so we need specific varialbes for the checks
                        keep = true;
                    }
                    return false;
                });
                if (siteSpecific) {
                    return false;
                }
                if (remove) {
                    return false;
                }
                return keep;
            });
            return _this.state.filteredPayload;
        };
        this.state = {
            config: config,
            filteredPayload: {}
        };
    }
    Object.defineProperty(App.prototype, "config", {
        get: function () {
            return this.state.config;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(App.prototype, "filteredPayload", {
        get: function () {
            return this.state.filteredPayload;
        },
        enumerable: true,
        configurable: true
    });
    App.checkForConfig = function (path) {
        return fs.existsSync(path);
    };
    App.getConfig = function (path) { return __awaiter(_this, void 0, void 0, function () {
        var error_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 4, , 5]);
                    if (!App.checkForConfig(path)) return [3 /*break*/, 2];
                    return [4 /*yield*/, jsonfile.readFile(path)];
                case 1: return [2 /*return*/, _a.sent()];
                case 2: throw new Error('cant find config exists please change the name or call createConfigTemplate');
                case 3: return [3 /*break*/, 5];
                case 4:
                    error_1 = _a.sent();
                    throw error_1;
                case 5: return [2 /*return*/];
            }
        });
    }); };
    App.createConfigTemplate = function (template, name) { return __awaiter(_this, void 0, void 0, function () {
        var err_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, configFactory_1.createConfig(template, name)];
                case 1:
                    _a.sent();
                    return [3 /*break*/, 3];
                case 2:
                    err_1 = _a.sent();
                    console.error(err_1);
                    throw new Error('could not create config template');
                case 3: return [2 /*return*/];
            }
        });
    }); };
    return App;
}());
exports.App = App;
