/// <reference path="../../src/types/jsonfile/index.d.ts" />
import { ConfigConstructor, ConfigInterface, ConfigOutput, KeyPair } from '../interfaces/Config';
export declare const configFactory: (ctor: ConfigConstructor, { toKeep, toRemove, siteSpecificKey, keepAlive, inputPath, outputPath }: ConfigInterface) => ConfigInterface;
export declare class Config implements ConfigInterface {
    toKeep: KeyPair[];
    toRemove: KeyPair[];
    siteSpecificKey: string;
    keepAlive: boolean;
    inputPath: string;
    outputPath: ConfigOutput;
    constructor(toKeep: KeyPair[], toRemove: KeyPair[], siteSpecificKey: string, keepAlive: boolean, inputPath: string, outputPath: ConfigOutput);
}
export declare const createConfig: (configInput: ConfigInterface, configOutputPath: string) => Promise<void>;
