"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var fs = require("fs");
var convert = require("xml-js");
var deepClone = function (obj) {
    return JSON.parse(JSON.stringify(obj));
};
exports.filterXML = function (path, cb) {
    var file = fs.readFileSync(path, 'utf-8');
    var json = convert.xml2js(file, { ignoreComment: true, alwaysChildren: true });
    var keepClone = deepClone(json);
    var removeClone = deepClone(json);
    var keepSlots = [];
    var removeSlots = [];
    for (var _i = 0, _a = json.elements[0].elements; _i < _a.length; _i++) {
        var slot = _a[_i];
        if (cb(slot)) {
            keepSlots.push(slot);
        }
        else {
            removeSlots.push(slot);
        }
    }
    keepClone.elements[0].elements = keepSlots;
    removeClone.elements[0].elements = removeSlots;
    return {
        keep: keepClone,
        remove: removeClone
    };
};
